precision highp float;

uniform sampler2D u_text;

varying highp vec2 textureCoordinate;

uniform float u_startTime;
uniform float u_endTime;
uniform float u_currentTime;

void main() {
    float current = u_currentTime - u_startTime;
    float total = u_endTime - u_startTime;

    float intensity; 
    if (current < total / 3.0) {
        intensity = 0.5 + 1.5 * current / total;
    }
    else if (current < total * 2.0 / 3.0) {
        intensity = 1.0;
    }
    else {
        intensity = 3.0 * (total - current) / total;
    }
    float alpha = texture2D(u_text, textureCoordinate).a;

    vec4 color = vec4(alpha, alpha, alpha, alpha) * intensity;
    gl_FragColor = color;
}

