precision highp float;

uniform sampler2D u_text;
uniform sampler2D u_text_blur;

varying highp vec2 textureCoordinate;

uniform float showAlpha; // 0->1



void main() {

    float alpha = texture2D(u_text, textureCoordinate).r;
    float alphaBlur = texture2D(u_text_blur, textureCoordinate).r;
    float alphaMix = mix(alphaBlur, alpha, showAlpha); // 模糊程度逐渐减小

    gl_FragColor = vec4(alphaMix*showAlpha); // 不透明度逐渐增大


}

