precision highp float;

attribute vec3 attPosition;
attribute vec2 attUV;

uniform int u_width;
uniform int u_height;
uniform float u_d_width_offset;
uniform float u_d_height_offset;

uniform vec2 u_pos;

varying highp vec2 textureCoordinate;

void main() {
    vec2 weight = vec2(float(u_width) * u_d_width_offset, float(u_height) * u_d_height_offset);
    vec2 pos = u_pos + 0.5 * (attPosition.xy + 1.0) * weight;
    gl_Position = vec4(pos * 2.0 - 1.0, 0.0, 1.0);

    textureCoordinate = attUV.xy;
}

