precision highp float;

attribute vec3 attPosition;
attribute vec2 attUV;

uniform int u_width;
uniform int u_height;
uniform float u_d_width_offset;
uniform float u_d_height_offset;
uniform vec2 u_pos;
uniform float u_intensity;

varying highp vec2 textureCoordinate;
varying highp float alpha;

void main() {
    float scale = 1.0 + u_intensity * 3.5;
    alpha = 1.0 - u_intensity;

    vec2 weight = vec2(float(u_width) * u_d_width_offset, float(u_height) * u_d_height_offset);
    vec2 pos = (u_pos - 0.5) * 2.0 + attPosition.xy * weight * scale;
    pos.y = pos.y + float(u_height) * u_d_height_offset * 0.5;
    gl_Position = vec4(pos, 0.0, 1.0);
    textureCoordinate = attUV.xy;
}

