local initFlag = false
local lastId = -1
local init_count = 2
local nextId = -1
function find_srt(srt_data, time)
    local count = srt_data:count()
    for i = 0, count - 1 do
        local srt_line = srt_data:data(i)
        if srt_line:endTime() >= time and srt_line:startTime() <= time then
            return i
        end
    end
    return -1
end

function add_texture(this, text2d, srt_line)
    text2d:pushCommandMove("display_texture", "display_texture2")
    text2d:pushCommandRemove("display_texture")
    local effectManager = this:getEffectManager()
    if not effectManager then
        return
    end
    local inputWidth = effectManager:getInputWidth()
    local inputHeight = effectManager:getInputHeight()
    if srt_line then
        text2d:pushCommandGenerate("display_texture", srt_line:text(), srt_line:length(), 
            44 / inputHeight, 0, 518.4 / inputWidth, 1.2, 1, 0, 1)

            -- text2d:pushCommandGenerate("display_texture", srt_line:text(), srt_line:length(), 
            -- 44 / 1280, 0, 518.4 / 720, 1, 1, 0, 1)
    end
end

local split_time = 0.1
local swap_flag = false
local init_flag = true

function handleEvent(this) 
    local feature = this:getFeature("text")
    if not feature then
        return
    end
    local text2d = EffectSdk.castText2DFeature(feature)

    local effectManager = this:getEffectManager()
    if not effectManager then
        return
    end
    local time = effectManager:getMusicCurrentTime()
    
    if effectManager:getFontStatus() then
        text2d:updateFontPath()
    end
    
    if effectManager:getSRTStatus() then
        effectManager:swapSRTIndex()
        nextId = -1
    end
    local srt_data = effectManager:getSRTData()
    local inputWidth = effectManager:getInputWidth()
    local inputHeight = effectManager:getInputHeight()
    local  yOffset = (0.28125 * 1280 + (inputHeight - 1280) / 2.0) / inputHeight
    -- EffectSdk.LOG_LEVEL(6, "inputWidth: " .. inputWidth .. ", inputHeight: " .. inputHeight)

    local id = find_srt(srt_data, time)
    if id ~= -1 then
        local srt_line = srt_data:data(id)
        local startTime = srt_line:startTime()
        local endTime = srt_line:endTime()

        local intensity = 1.0
        local used_split_time = split_time

        if lastId ~= id or init_count > 0 then
            if (id == nextId) then
                text2d:pushCommandMove("display_texture", "display_texture2")
                id = -1
            else
                text2d:pushCommandGenerate("display_texture", srt_line:text(), srt_line:length(), 
                44 / inputHeight, 0, 518.4 / inputWidth, 1.2, 1, 0, 1)
                -- text2d:pushCommandGenerate("display_texture", srt_line:text(), srt_line:length(), 
                -- 44 / 1280, 0, 518.4 / 720, 1, 1, 0, 1)
            end
            lastId = id
            init_count = init_count - 1
            -- text2d:pushCommandMove("display_texture", "display_texture2")
        end


        if endTime - startTime < 2 * split_time then
            used_split_time = (endTime - startTime) / 2.0
            swap_flag = false
        end
        if startTime > time - used_split_time then
            intensity = 0.5 + (time - startTime) / used_split_time / 2.0
        elseif endTime < time + used_split_time then
            intensity = (time + used_split_time - endTime) / used_split_time / 2.0
            if not swap_flag then
                swap_flag = true
                -- swap texture
                if id < srt_data:count() - 1 then
                    add_texture(this, text2d, srt_data:data(id + 1))
                    nextId = id + 1
                else
                    add_texture(this, text2d, nil)
                    nextId = -1
                end
            end
        else
            swap_flag = false
        end

        -- setIntensity逻辑
        local feature = this:getFeature("PutFrame/")
        if not feature then
            return
        end
        local ge = EffectSdk.castGeneralEffectFeature(feature)

        local feature2 = this:getFeature("PutFrame2/")
        if not feature2 then
            return
        end
        local ge2 = EffectSdk.castGeneralEffectFeature(feature2)

        ge:setUniformFloat("text1", 1, "u_intensity", intensity)
        ge:setUniformVec2("text1", 1, "u_pos", 0.5, yOffset)
        ge2:setUniformFloat("text2", 1, "u_intensity", intensity)
        ge2:setUniformVec2("text2", 1, "u_pos", 0.5, yOffset)

        -- print(intensity)
        -- lastId = id
    else

    end
end

EventHandles =
{
    handleEffectEvent = function (this, eventCode)
        if (initFlag) then
            return true
        end
        initFlag = true
        handleEvent(this)
        
        this:addTimer( 3214349, EffectSdk.BEF_TIMER_EVENT_CIRCLE, 10)
        local feature = this:getFeature("text")
        local text2d = EffectSdk.castText2DFeature(feature)
        text2d:updateFontPath()
        return true
    end,
    handleTimerEvent = function (this, timerId, milliSeconds)
        handleEvent(this)
        return true
    end
}
