local initFlag = false
local nowCount = -1
local init_count = 2

local playingIndex = -1
local playing = false

local geFeaturePath = "PutFrame/"
local ptFontSize = 58
local width = 620.0

local featurePath = "2DStickerV3/"
local strCnt = 0
local duration = {1.5, 3.6}
local stringTotal = 6
local flag = false

local mTimerId = 67183

local strStartDuration = 500 -- 0.5s
local diffStrDuration = 1000 -- 1s

local showTime = 0.3

local preRandomIdx = 0

local topDis = 0.21
local leftDis = 0.69
local width2DV3 = {436, 493, 281, 600, 621, 610}
local height2DV3 = {246, 263, 235, 125, 251, 181}

function print_line(this, text2d, ge, srt_data, time)
    local count = srt_data:count()
    local effectManager = this:getEffectManager()
    if not effectManager then
        return
    end
    local inputWidth = effectManager:getInputWidth()
    local inputHeight = effectManager:getInputHeight()
    local yOffset = (0.21 * 1280 + (inputHeight - 1280) / 2.0) / inputHeight

    for i=0,count-1 do
        local srt_line = srt_data:data(i)
        local startTime = srt_line:startTime()
        local endTime = srt_line:endTime()

        if endTime >= time and startTime <= time then
            -- print("time:", startTime, time, endTime)
            if i ~= nowCount or init_count > 0 then
                local curDuration = endTime - startTime
                if (curDuration < duration[1]) then
                    strCnt = 0
                elseif (curDuration < duration[2]) then
                    strCnt = 1
                    flag = true
                else
                    flag = true
                    strCnt = 2
                end

                text2d:pushCommandGenerate("display_texture", srt_line:text(), srt_line:length(), 
                ptFontSize / inputHeight, 0, width / inputWidth, 1.3, 0, 0, 1)  --518.4
                nowCount = i
                init_count = init_count - 1
            end
            ge:setUniformFloat("text1", 1, "u_startTime", startTime)
            ge:setUniformFloat("text1", 1, "u_endTime", endTime)
            ge:setUniformFloat("text1", 1, "u_currentTime", time)
            ge:setUniformVec2("text1", 1, "u_pos", 0.069, yOffset)

            local showAlpha = 1.0
            if endTime - startTime > showTime then
                showAlpha = (time-startTime) / showTime
                if showAlpha > 1.0 then
                    showAlpha = 1.0
                end
            end
            ge:setUniformFloat("text1", 1, "showAlpha", showAlpha)

            break
        end
    end
end

function handleEvent(this, timerId)
    if timerId == 3214349 then
        local feature = this:getFeature("text")
        if not feature then
            return
        end
        local text2d = EffectSdk.castText2DFeature(feature)
        local feature2 = this:getFeature(geFeaturePath)
        if not feature2 then
            return
        end
        local ge = EffectSdk.castGeneralEffectFeature(feature2)

        local effectManager = this:getEffectManager()
        if not effectManager then
            return
        end
        if effectManager:getFontStatus() then
            text2d:updateFontPath()
        end

        local time = effectManager:getMusicCurrentTime()
        -- local audio_effect = this:getAudioManager()
        -- local time = audio_effect:getCurrentPlayTime()
        
        if effectManager:getSRTStatus() then
            effectManager:swapSRTIndex()
        end
        local srt_data = effectManager:getSRTData()
        print_line(this, text2d, ge, srt_data, time)
        if (flag) then
            flag = false
            local feature = this:getFeature(featurePath)
            if(feature) then
                mTimerId = mTimerId + 1
                feature:addTimer(mTimerId, EffectSdk.BEF_TIMER_EVENT_ONCE, strStartDuration)
            end
        end
    end

    if timerId == mTimerId then
        strCnt = strCnt - 1
        local feature = this:getFeature(featurePath)
        if not feature then
            return
        end
        local feature2DV3 = EffectSdk.castSticker2DV3Feature(feature)
        local curIdx = math.random(stringTotal)
        while (curIdx == preRandomIdx) do
            curIdx = math.random(stringTotal)
        end
        local effectManager = this:getEffectManager()
        if effectManager then
            local rect = effectManager:getRenderCacheSize("display_texture")
            local width = effectManager:getInputWidth()
            local height = effectManager:getInputHeight()
            if feature and feature2DV3 then
                local textHeight = rect.bottom - rect.top
                local centerX = 0.5
                local centerY = topDis + textHeight/2
                feature2DV3:setVertices("entity", "s"..curIdx, 0, centerX - width2DV3[curIdx] * 0.5 / width, centerY - height2DV3[curIdx] * 0.5 / height)
                feature2DV3:setVertices("entity", "s"..curIdx, 1, centerX + width2DV3[curIdx] * 0.5 / width, centerY - height2DV3[curIdx] * 0.5 / height)
                feature2DV3:setVertices("entity", "s"..curIdx, 2, centerX - width2DV3[curIdx] * 0.5 / width, centerY + height2DV3[curIdx] * 0.5 / height)
                feature2DV3:setVertices("entity", "s"..curIdx, 3, centerX + width2DV3[curIdx] * 0.5 / width, centerY + height2DV3[curIdx] * 0.5 / height)

                -- if playing, stop last animation
                if(playing and playingIndex > 0) then
                    feature2DV3:appearClip("entity", "s"..playingIndex,false)
                    feature2DV3:resumeClip("entity", "s"..playingIndex,false) 
                    feature2DV3:resetClip("entity","s"..playingIndex)
                end

                feature2DV3:appearClip("entity", "s"..curIdx,false)
                feature2DV3:resumeClip("entity", "s"..curIdx,false) 
                feature2DV3:resetClip("entity","s"..curIdx)
                feature2DV3:playClip("entity", "s"..curIdx, -1, 1)

                playing = true
                playingIndex = curIdx
            end
        end
        preRandomIdx = curIdx
    end
end

EventHandles =
{
    handleEffectEvent = function (this, eventCode)

        if eventCode == 1 then
            if (initFlag) then
                return true
            end
            initFlag = true

            local timerId = 3214349

            handleEvent(this, timerId)

            -- local bgm = this:getAudioManager()
            -- if(bgm) then
            --     bgm:setLoop(1)
            --     bgm:startPlay()
            -- end
            this:addTimer(timerId, EffectSdk.BEF_TIMER_EVENT_CIRCLE, 10)
            
            local feature = this:getFeature("text")
            if feature then
                local text2d = EffectSdk.castText2DFeature(feature)
                text2d:updateFontPath()
            end
        end
        return true
    end,
    handleTimerEvent = function (this, timerId, milliSeconds)
        handleEvent(this, timerId)
        return true
    end,
    handleAnimationEvent = function (this, entityName, clipName, eventCode)
        if(entityName=="entity" and eventCode==2) then
            playing = false
            playingIndex = -1
        end
        if(entityName=="entity" and eventCode==2 and strCnt > 0) then
            local feature = this:getFeature(featurePath)
            if(feature) then
                mTimerId = mTimerId + 1
                feature:addTimer(mTimerId, EffectSdk.BEF_TIMER_EVENT_ONCE, diffStrDuration)
            end
        end
        return true
    end,

}
