local initFlag = false
local nowCount = -1
local init_count = 2
local geFeaturePath = "PutFrame/"
local ptFontSize = 70
local width = 620.0
local featurePath = "2DStickerV3/"
local strCnt = 0
local duration = {1.8, 3.1}
local stringTotal = 7
local flag = false
local mTimerId = 67183
local strStartDuration = 500 -- 0.5s
local diffStrDuration = 800 -- 0.8s
local showTime = 0.3
local preRandomIdx = 0
local curPosIdx = 1
local topDis = 0.28
local leftDis = 0.69
local width2DV3 = 350.0
local height2DV3 = 350.0
local arrowsBallAspectRatio = 0.666666
local arrowsCenterX = 360.0 / 720.0
local arrowsCenterY = 719.0 / 1280.0
local preRandomPosIdx = 0
local GEGuitarPath = "GE_guitar/"
local normWidth = 720.
local normHeight = 1280.
local guitarPos = {
    {573.0, -181.0},
    {573.0, 660.0},
    {573.0, 660.0},
    {166.0, 1508.0}
}
local guitarTime = {0., 0.5, 1.2, 1.5}
local guitarAngle = {-45.0, 405.0, 405.0, 765.0}
local guitarAlpha = {1., 1., 1., 0.34}
local startTime = 0.0
local GEGuitarEnable = false
math.randomseed(os.time())

function updateStartTime(this)
    local effectManager = this:getEffectManager()
    if effectManager then startTime = effectManager:getTimeStamp() end
    return true
end

function getDuration(this)
    local effectManager = this:getEffectManager()
    if effectManager then
        local ts = effectManager:getTimeStamp()
        local duration = ts - startTime
        return duration
    end
end

function getVal(refMin, refMax, refVal, min, max)
    local ret = (min * (refMax - refVal) + max * (refVal - refMin)) / (refMax - refMin)
    return ret
end

function print_line(this, text2d, ge, srt_data, time)
    local count = srt_data:count()

    local effectManager = this:getEffectManager()
    if not effectManager then
        return
    end
    local inputHeight = effectManager:getInputHeight()
    local inputWidth = effectManager:getInputWidth()
    for i = 0, count - 1 do
        local srt_line = srt_data:data(i)
        local startTime = srt_line:startTime()
        local endTime = srt_line:endTime()

        if endTime >= time and startTime <= time then
            print("time:", startTime, time, endTime)
            if i ~= nowCount or init_count > 0 then
                -- 每句歌词只处罚一次
                local curDuration = endTime - startTime
                if (curDuration < duration[1]) then
                    strCnt = 0
                elseif (curDuration < duration[2]) then
                    strCnt = 1
                    flag = true
                else
                    flag = true
                    strCnt = 2
                end

                text2d:pushCommandGenerate(
                    "display_texture",
                    srt_line:text(),
                    srt_line:length(),
                    ptFontSize / inputHeight,
                    0,
                    width / inputWidth,
                    1.3,
                    1,
                    0,
                    1
                ) -- 518.4
                nowCount = i
                init_count = init_count - 1
            end
            ge:setUniformFloat("text1", 1, "u_startTime", startTime)
            ge:setUniformFloat("text1", 1, "u_endTime", endTime)
            ge:setUniformFloat("text1", 1, "u_currentTime", time)

            local yOffset = (0.285 * 1280 + (inputHeight - 1280) / 2.0) / inputHeight
            ge:setUniformVec2("text1", 1, "u_pos", 0.069, yOffset) --  [0.069, 0.285]
            -- ge:setUniformVec2("text1", 1, "u_pos", 0.069 / 720.0 * inputWidth, 0.285  / 1280.0 * inputHeight)

            -- ge:setUniformVec2("text1", 1, "u_pos", 0.069 / 720.0 * inputWidth, 0.285) --  [0.069, 0.285]
            local showAlpha = 1.0
            if endTime - startTime > showTime then
                showAlpha = (time - startTime) / showTime
                if showAlpha > 1.0 then showAlpha = 1.0 end
            end
            ge:setUniformFloat("text1", 1, "showAlpha", showAlpha)

            break
        end
    end
end

EventHandles = {
    handleEffectEvent = function(this, eventCode)

        if eventCode == 1 then
            if (initFlag) then return true end
            initFlag = true
            -- local bgm = this:getAudioManager()
            -- if (bgm) then
            --     bgm:setLoop(1)
            --     bgm:startPlay()
            -- end

            this:addTimer(3214349, EffectSdk.BEF_TIMER_EVENT_CIRCLE, 10)

            local feature = this:getFeature("text")
            if feature then
                local text2d = EffectSdk.castText2DFeature(feature)
                -- text2d:updateFontPath("../fzlt.ttf", 0)
                text2d:updateFontPath()
            end
        end
        return true
    end,
    handleTimerEvent = function(this, timerId, milliSeconds)
        if timerId == 3214349 then
            local feature = this:getFeature("text")
            if not feature then
                return
            end
            local text2d = EffectSdk.castText2DFeature(feature)
            local feature2 = this:getFeature(geFeaturePath)
            if not feature2 then
                return
            end
            local ge = EffectSdk.castGeneralEffectFeature(feature2)

            local effectManager = this:getEffectManager()
            if not effectManager then
                return
            end
            if effectManager:getFontStatus() then text2d:updateFontPath() end

            local time = effectManager:getMusicCurrentTime()
            -- local audio_effect = this:getAudioManager()
            -- local time = audio_effect:getCurrentPlayTime()

            if effectManager:getSRTStatus() then effectManager:swapSRTIndex() end
            local srt_data = effectManager:getSRTData()

            if feature and text2d and feature2 and ge then print_line(this, text2d, ge, srt_data, time) end
            if (flag) then
                flag = false
                local feature = this:getFeature(featurePath)
                if (feature) then
                    mTimerId = mTimerId + 1
                    feature:addTimer(
                        mTimerId,
                        EffectSdk.BEF_TIMER_EVENT_ONCE,
                        strStartDuration
                    )
                end
            end
            --- ge guitar ---
            if GEGuitarEnable then
                local duration = getDuration(this)
                if duration < guitarTime[#guitarTime] then
                    for i = 2, #guitarTime do
                        if duration < guitarTime[i] then
                            local alpha = getVal(
                                guitarTime[i - 1],
                                guitarTime[i],
                                duration,
                                guitarAlpha[i - 1],
                                guitarAlpha[i]
                            )
                            local posX = getVal(
                                guitarTime[i - 1],
                                guitarTime[i],
                                duration,
                                guitarPos[i - 1][1],
                                guitarPos[i][1]
                            )
                            local posY = getVal(
                                guitarTime[i - 1],
                                guitarTime[i],
                                duration,
                                guitarPos[i - 1][2],
                                guitarPos[i][2]
                            )
                            local angle = getVal(
                                guitarTime[i - 1],
                                guitarTime[i],
                                duration,
                                guitarAngle[i - 1],
                                guitarAngle[i]
                            )
                            angle = math.mod(angle, 360)
                            angle = angle / 180.0 * math.pi

                            posX = posX / normWidth
                            posY = posY / normHeight -- 0~1
                            posX = posX * 2.0 - 1.0 -- center -1~1
                            posY = posY * 2.0 - 1.0
                            feature = this:getFeature(GEGuitarPath)
                            if feature then
                                thisFeature = EffectSdk.castGeneralEffectFeature(feature)
                                if feature and thisFeature then
                                    thisFeature:setUniformVec2("words", 1, "center", posX, posY)
                                    thisFeature:setUniformFloat("words", 1, "alpha", alpha)
                                    thisFeature:setUniformFloat("words", 1, "angle", angle)
                                end
                            end
                            break
                        end
                    end
                else
                    -- ge guitar 播放完 ---
                    local feature = this:getFeature(GEGuitarPath)
                    if feature then
                        feature:setFeatureStatus(EffectSdk.BEF_FEATURE_STATUS_ENABLED, false)
                    end
                    GEGuitarEnable = false
                    strCnt = strCnt - 1
                    if strCnt > 0 then
                        local feature = this:getFeature(featurePath)
                        if (feature) then
                            mTimerId = mTimerId + 1
                            feature:addTimer(
                                mTimerId,
                                EffectSdk.BEF_TIMER_EVENT_ONCE,
                                diffStrDuration
                            )
                        end
                    end
                end
            end
        end

        if timerId == mTimerId then
            strCnt = strCnt - 1
            local feature = this:getFeature(featurePath)
            if not feature then
                return
            end
            local feature2DV3 = EffectSdk.castSticker2DV3Feature(feature)
            local curIdx = math.random(stringTotal)
            while (curIdx == preRandomIdx) do curIdx = math.random(stringTotal) end
            preRandomIdx = curIdx

            if curIdx <= 6 then
                if curIdx <= 5 then
                    local indexTable = {}
                    for i = 1, 3 do
                        if i ~= preRandomPosIdx then table.insert(indexTable, i) end
                    end
                    curPosIdx = indexTable[math.random(#indexTable)]
                    preRandomPosIdx = curPosIdx
                end

                local effectManager = this:getEffectManager()
                if effectManager then
                    local rect = effectManager:getRenderCacheSize("display_texture")
                    local width = effectManager:getInputWidth()
                    local height = effectManager:getInputHeight()
                    if feature and feature2DV3 then
                        local textHeight = rect.bottom - rect.top

                        local normWidthSticker = 0.0
                        local normHeightSticker = 0.0
                        local centerX = 0.0
                        local centerY = 0.0

                        if curIdx <= 5 then
                            centerX = 0.5
                            centerY = topDis + textHeight + height2DV3 * 0.5 / height
                            if curPosIdx == 1 then
                                centerX = width2DV3 * 0.5 / width
                            elseif curPosIdx == 3 then
                                centerX = 1.0 - width2DV3 * 0.5 / width
                            end
                            -- print("||curPosIdxfinal: " .. curPosIdx)
                            -- print("||centerX: " .. centerX)
                            -- print("||width2DV3: " .. width2DV3)
                            -- print("||width: " .. width)

                            normWidthSticker = width2DV3 / width
                            normHeightSticker = height2DV3 / height
                        else
                            centerX = arrowsCenterX
                            centerY = arrowsCenterY
                            normWidthSticker = 1.0
                            normHeightSticker = arrowsBallAspectRatio * (width / height)
                        end
                        feature2DV3:setVertices(
                            "entity",
                            "s" .. curIdx,
                            0,
                            centerX - normWidthSticker * 0.5,
                            centerY - normHeightSticker * 0.5
                        )
                        feature2DV3:setVertices(
                            "entity",
                            "s" .. curIdx,
                            1,
                            centerX + normWidthSticker * 0.5,
                            centerY - normHeightSticker * 0.5
                        )
                        feature2DV3:setVertices(
                            "entity",
                            "s" .. curIdx,
                            2,
                            centerX - normWidthSticker * 0.5,
                            centerY + normHeightSticker * 0.5
                        )
                        feature2DV3:setVertices(
                            "entity",
                            "s" .. curIdx,
                            3,
                            centerX + normWidthSticker * 0.5,
                            centerY + normHeightSticker * 0.5
                        )

                        feature2DV3:appearClip("entity", "s" .. curIdx, false)
                        feature2DV3:resumeClip("entity", "s" .. curIdx, false)
                        feature2DV3:resetClip("entity", "s" .. curIdx)
                        feature2DV3:playClip("entity", "s" .. curIdx, -1, 1)
                    end
                end
            else
                -- GE guitar
                local feature = this:getFeature(GEGuitarPath)
                if feature then
                    feature:setFeatureStatus(EffectSdk.BEF_FEATURE_STATUS_ENABLED, true)
                end
                updateStartTime(this)
                GEGuitarEnable = true
            end

        end

        return true
    end,
    handleAnimationEvent = function(this, entityName, clipName, eventCode)
        if (entityName == "entity" and eventCode == 2 and strCnt > 0) then
            local feature = this:getFeature(featurePath)
            if (feature) then
                mTimerId = mTimerId + 1
                feature:addTimer(
                    mTimerId,
                    EffectSdk.BEF_TIMER_EVENT_ONCE,
                    diffStrDuration
                )
            end
        end
        return true
    end,

}
