local initFlag = false
local nowCount = -1
local init_count = 2
local geFeaturePath = "PutFrame/"
function print_line(this, text2d, ge, srt_data, time)
    local count = srt_data:count()
    local effectManager = this:getEffectManager()
    local inputHeight = effectManager:getInputHeight()
    local inputWidth = effectManager:getInputWidth()

    for i=0,count-1 do
        local srt_line = srt_data:data(i)
        local startTime = srt_line:startTime()
        local endTime = srt_line:endTime()

        if endTime >= time and startTime <= time then
            print("time:", startTime, time, endTime)
            if i ~= nowCount or init_count > 0 then
                text2d:pushCommandGenerate("display_texture", srt_line:text(), srt_line:length(), 
                        48 / inputHeight, 0, 518.4 / inputWidth, 1.2, 0, 0, 1)
                nowCount = i
                init_count = init_count - 1
            end
            ge:setUniformFloat("text1", 1, "u_startTime", startTime)
            ge:setUniformFloat("text1", 1, "u_endTime", endTime)
            ge:setUniformFloat("text1", 1, "u_currentTime", time)

            local yOffset = (0.26 * 1280 + (inputHeight - 1280) / 2.0) / inputHeight
            ge:setUniformVec2("text1", 1, "u_pos", 0.14, yOffset) -- [0.14, 0.26]
            

            break
        end
    end
end

EventHandles =
{
    handleEffectEvent = function (this, eventCode)
        if (initFlag) then
            return true
        end
        initFlag = true
        
        this:addTimer( 3214349, EffectSdk.BEF_TIMER_EVENT_CIRCLE, 10)
        
        local feature = this:getFeature("text")
        local text2d = EffectSdk.castText2DFeature(feature)
        text2d:updateFontPath()
        return true
    end,
    handleTimerEvent = function (this, timerId, milliSeconds)
        local feature = this:getFeature("text")
        if not feature then
            return
        end
        local text2d = EffectSdk.castText2DFeature(feature)
        local feature2 = this:getFeature(geFeaturePath)
        if not feature2 then
            return
        end
        local ge = EffectSdk.castGeneralEffectFeature(feature2)

        local effectManager = this:getEffectManager()
        if effectManager:getFontStatus() then
            text2d:updateFontPath()
        end

        local time = effectManager:getMusicCurrentTime()

        if effectManager:getSRTStatus() then
            effectManager:swapSRTIndex()
        end
        local srt_data = effectManager:getSRTData()
        print_line(this, text2d, ge, srt_data, time)

        return true
    end
}
