local initFlag = false
local nowCount = -1
local init_count = 2
local nextId = -1
local geFeaturePath = "PutFrame/"
local geFeaturePath2 = "PutFrame2/"

function print_line(this, text2d, ge, ge2, srt_data, time)
    local effectManager = this:getEffectManager()
    if not effectManager then
        return
    end
    local count = srt_data:count()
    local inputWidth = effectManager:getInputWidth()
    local inputHeight = effectManager:getInputHeight()

    -- print("count:", count)
    for i=0,count-1 do
        local srt_line = srt_data:data(i)
        local startTime = srt_line:startTime()
        local endTime = srt_line:endTime()
        if endTime >= time and startTime <= time then
            --print("time:", startTime, time, endTime)
            if i ~= nowCount or init_count > 0 then
                if (i == nextId and nextId ~= -1) then
                    text2d:pushCommandMove("display_texture2", "display_texture")
                    text2d:pushCommandRemove("display_texture2")
                    nextId = -1
                else
                    text2d:pushCommandGenerate("display_texture", srt_line:text(), srt_line:length(), 
                        36 / 1280, 0, 518.4 / 720, 1.2, 0, 0, 1)
                end
                
                nowCount = i
                init_count = init_count - 1
                if i < count - 1 then
                    local srt_line2 = srt_data:data(i + 1)
                    text2d:pushCommandGenerate("display_texture2", srt_line2:text(), srt_line2:length(), 
                            36 / 1280, 0, 518.4 / 720, 1.2, 0, 0, 1)
                    nextId = i + 1
                else
                    text2d:pushCommandRemove("display_texture2")
                    nextId = -1
                end
            end
            
            if (i % 4 == 0) then
                ge:setUniformVec2("text1", 1, "u_pos", 0.14, (0.3878125 * 1280 + (inputHeight - 1280) / 2.0) / inputHeight)
                ge2:setUniformVec2("text2", 1, "u_pos", 0.14, (0.4878125 * 1280 + (inputHeight - 1280) / 2.0) / inputHeight)
            elseif (i % 4 == 1) then
                ge:setUniformVec2("text1", 1, "u_pos", 0.14, (0.4878125 * 1280 + (inputHeight - 1280) / 2.0) / inputHeight)
                ge2:setUniformVec2("text2", 1, "u_pos", 0.14, (0.5878125 * 1280 + (inputHeight - 1280) / 2.0) / inputHeight)
            elseif (i % 4 == 2) then
                ge:setUniformVec2("text1", 1, "u_pos", 0.14, (0.5878125 * 1280 + (inputHeight - 1280) / 2.0) / inputHeight)
                ge2:setUniformVec2("text2", 1, "u_pos", 0.14, (0.6878125 * 1280 + (inputHeight - 1280) / 2.0) / inputHeight)
            elseif (i % 4 == 3) then
                ge:setUniformVec2("text1", 1, "u_pos", 0.14, (0.6878125 * 1280 + (inputHeight - 1280) / 2.0) / inputHeight)
                ge2:setUniformVec2("text2", 1, "u_pos", 0.14, (0.3878125 * 1280 + (inputHeight - 1280) / 2.0) / inputHeight)
            end
            ge:setUniformFloat("text1", 1, "u_startTime", startTime)
            ge:setUniformFloat("text1", 1, "u_endTime", endTime)
            ge:setUniformFloat("text1", 1, "u_currentTime", time)
            ge2:setUniformFloat("text2", 1, "u_startTime", startTime)
            ge2:setUniformFloat("text2", 1, "u_endTime", endTime)
            ge2:setUniformFloat("text2", 1, "u_currentTime", time)
            
            
            break
        end
    end
end

function handleEvent(this)
    local feature = this:getFeature("text")
    if not feature then
        return
    end
    local text2d = EffectSdk.castText2DFeature(feature)

    local feature2 = this:getFeature(geFeaturePath)
    if not feature2 then
        return
    end
    local ge = EffectSdk.castGeneralEffectFeature(feature2)

    local feature3 = this:getFeature(geFeaturePath2)
    if not feature3 then
        return
    end
    local ge2 = EffectSdk.castGeneralEffectFeature(feature3)

    local effectManager = this:getEffectManager()
    if not effectManager then
        return
    end
    if effectManager:getFontStatus() then
        text2d:updateFontPath()
    end
    
    local time = effectManager:getMusicCurrentTime()
    

    if effectManager:getSRTStatus() then
        effectManager:swapSRTIndex()
        nextId = -1
    end
    local srt_data = effectManager:getSRTData()
    
    print_line(this, text2d, ge, ge2, srt_data, time)
end

EventHandles =
{
    handleEffectEvent = function (this, eventCode)
        if (initFlag) then
            return true
        end
        initFlag = true
        handleEvent(this)
        
        this:addTimer( 3214349, EffectSdk.BEF_TIMER_EVENT_CIRCLE, 10)
        
        local feature = this:getFeature("text")
        local text2d = EffectSdk.castText2DFeature(feature)
        text2d:updateFontPath()
        return true
    end,
    handleTimerEvent = function (this, timerId, milliSeconds)
        handleEvent(this)
        return true
    end
}
